Imports TileServer
Imports System.Net
Imports System.Drawing

Public MustInherit Class Ask

    Implements IServer

    Protected ImageTypeValue As String
    Protected MaximumZoomValue As Integer
    Protected ServerNameValue As String
    Protected URL(3) As String
    Protected Function Tilename(ByVal X As Integer, ByVal Y As Integer, ByVal Zoom As Integer) As String

        Dim P As Integer = CInt(2 ^ Zoom)
        X = X - P
        Y = Y - P
        Tilename = (18 - Zoom).ToString & "/"
        Tilename = Tilename & X.ToString & "/"
        Tilename = Tilename & Y.ToString

    End Function

    Public Function DownloadTile(ByVal X As Integer, ByVal Y As Integer, ByVal Zoom As Integer, ByVal Filename As String) As Boolean Implements TileServer.IServer.DownloadTile
        Dim XY As Integer = 2 ^ (Zoom + 1)
        X = X Mod XY
        Y = Y Mod XY
        Dim Tile As String = Tilename(X, Y, Zoom)
        Dim S As Integer = (X + Y) Mod 4
        Dim imageURL As String = URL(S) & Tile

        Dim index As Integer
        Dim img As Image
        Try
            Dim req As Net.HttpWebRequest = DirectCast(Net.HttpWebRequest.Create(imageURL), Net.HttpWebRequest)
            Dim res As Net.HttpWebResponse = DirectCast(req.GetResponse, Net.HttpWebResponse)
            index = res.ContentType.IndexOf("image")
            If index > -1 Then
                img = Image.FromStream(res.GetResponseStream)
                img.Save(Filename)
                DownloadTile = True
            Else
                DownloadTile = False
            End If
            res.Close()
        Catch ex As Exception
            DownloadTile = False
        End Try
    End Function
    Public ReadOnly Property ImageType() As String Implements TileServer.IServer.ImageType
        Get
            ImageType = ImageTypeValue
        End Get
    End Property
    Public ReadOnly Property MaximumZoom() As Integer Implements TileServer.IServer.MaximumZoom
        Get
            MaximumZoom = MaximumZoomValue
        End Get
    End Property
    Public ReadOnly Property ServerName() As String Implements TileServer.IServer.ServerName
        Get
            ServerName = ServerNameValue
        End Get
    End Property
    Protected Property BaseURL0() As String
        Get
            BaseURL0 = URL(0)
        End Get
        Set(ByVal value As String)
            URL(0) = value
        End Set
    End Property
    Protected Property BaseURL1() As String
        Get
            BaseURL1 = URL(1)
        End Get
        Set(ByVal value As String)
            URL(1) = value
        End Set
    End Property
    Protected Property BaseURL2() As String
        Get
            BaseURL2 = URL(2)
        End Get
        Set(ByVal value As String)
            URL(2) = value
        End Set
    End Property
    Protected Property BaseURL3() As String
        Get
            BaseURL3 = URL(3)
        End Get
        Set(ByVal value As String)
            URL(3) = value
        End Set
    End Property


    Protected Property BaseImageType() As String
        Get
            BaseImageType = ImageTypeValue
        End Get
        Set(ByVal value As String)
            ImageTypeValue = value
        End Set
    End Property
    Protected Property BaseServerName() As String
        Get
            BaseServerName = ServerNameValue
        End Get
        Set(ByVal value As String)
            ServerNameValue = value
        End Set
    End Property
    Protected Property BaseMaximumZoom() As Integer
        Get
            BaseMaximumZoom = MaximumZoomValue
        End Get
        Set(ByVal value As Integer)
            MaximumZoomValue = value
        End Set
    End Property
End Class

Public Class AskSatellite : Inherits Ask
    Sub New()
        MyBase.New()
        BaseImageType = ".JPG"
        BaseMaximumZoom = 6
        BaseServerName = "AskSatellite"
        BaseURL0 = "http://mapstatic1.ask.com/sat/"
        BaseURL1 = "http://mapstatic2.ask.com/sat/"
        BaseURL2 = "http://mapstatic3.ask.com/sat/"
        BaseURL3 = "http://mapstatic4.ask.com/sat/"
        'BaseURL4 = "http://mapcache1.ask.com/sat/"
        'BaseURL5 = "http://mapcache2.ask.com/sat/"
        'BaseURL6 = "http://mapcache3.ask.com/sat/"
        'BaseURL7 = "http://mapcache4.ask.com/sat/"
        'http://mapcache2.ask.com/map/13/-2/-8
    End Sub

End Class

Public Class AskStreetMap : Inherits Ask
    Sub New()
        MyBase.New()
        BaseImageType = ".PNG"
        BaseMaximumZoom = 9
        BaseServerName = "AskStreetMap"
        BaseURL0 = "http://mapstatic1.ask.com/map/"
        BaseURL1 = "http://mapstatic2.ask.com/map/"
        BaseURL2 = "http://mapstatic3.ask.com/map/"
        BaseURL3 = "http://mapstatic4.ask.com/map/"
        'BaseURL4 = "http://mapcache1.ask.com/map/"
        'BaseURL5 = "http://mapcache2.ask.com/map/"
        'BaseURL6 = "http://mapcache3.ask.com/map/"
        'BaseURL7 = "http://mapcache4.ask.com/map/"
        'http://mapcache2.ask.com/map/13/-2/-8
    End Sub

End Class
